/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMotivoCancelacion;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaMotivoCancelacionController")
@Scope("prototype")
public class BusquedaMotivoCancelacionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<MotivoCancelacion> plwMotivoCancelacion;
    private MyListbox motivoCancelacionList;
    private Paging pagingMotivoCancelacion;
    private Textbox txtNombre;
    private Combobox cmbTipoMotivo;

    public Combobox getCmbTipoMotivo() {
        return cmbTipoMotivo;
    }

    public void setCmbTipoMotivo(Combobox cmbTipoMotivo) {
        this.cmbTipoMotivo = cmbTipoMotivo;
    }

    public Paging getPagingMotivoCancelacion() {
        return pagingMotivoCancelacion;
    }

    public void setPagingMotivoCancelacion(Paging pagingMotivoCancelacion) {
        this.pagingMotivoCancelacion = pagingMotivoCancelacion;
    }

    public MyListbox getMotivoCancelacionList() {
        return motivoCancelacionList;
    }

    public void setMotivoCancelacionList(MyListbox motivoCancelacionList) {
        this.motivoCancelacionList = motivoCancelacionList;
    }

    public PagedListWrapper<MotivoCancelacion> getPlwMotivoCancelacion() {
        return plwMotivoCancelacion;
    }

    public void setPlwMotivoCancelacion(PagedListWrapper<MotivoCancelacion> plwMotivoCancelacion) {
        this.plwMotivoCancelacion = plwMotivoCancelacion;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new MotivoCancelacion());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        motivoCancelacionList.setItemRenderer(new RenderMotivoCancelacion());
        motivoCancelacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                MotivoCancelacion mc = (MotivoCancelacion) motivoCancelacionList.getSelected();
                verPeriodo(mc);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(MotivoCancelacion mc) {
        if (mc == null) {
            return;
        }

        Map args = new HashMap();
        args.put("motivoCancelacion", mc);
        args.put("motivoCancelacionList", motivoCancelacionList);

        openWindow("/gui/configuraciones_comerciales/editarMotivoCancelacion.zul",
                Labels.getLabel("editarMotivoCancelacionController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<MotivoCancelacion> claseServicioBusqueda =
                new HibernateSearchObject<MotivoCancelacion>(MotivoCancelacion.class, pagingMotivoCancelacion.getPageSize());

        Comboitem ci = cmbTipoMotivo.getSelectedItem();
        String tipoMotivo = null;
        if (ci != null) {
            tipoMotivo = (String) ci.getValue();
        }

        claseServicioBusqueda.addFilterLike("descmotivo", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("tipomotivo", tipoMotivo);
        claseServicioBusqueda.addFilterEqual("activo", true);
        claseServicioBusqueda.addSortAsc("descmotivo");

        plwMotivoCancelacion.init(claseServicioBusqueda, motivoCancelacionList, pagingMotivoCancelacion);

        if (motivoCancelacionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaMotivoCancelacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
